<?php
 
/*
 
Plugin Name: Current Year Shortcode (for Post Titles)
 
Plugin URI: 
 
Description: Display the current year in post and page titles.

Version: 1.0
 
Author: WCDev
 
Author URI: 
 
License: GPLv2 or later
 
Text Domain: current-year-shortcode-for-post-titles
 
*/

class WCCurrentYearShortcode {
	private $wc_current_year_shortcode_options;

	public function __construct() {
		add_action( 'admin_menu', array( $this, 'wc_current_year_shortcode_add_plugin_page' ) );
		add_action( 'admin_init', array( $this, 'wc_current_year_shortcode_page_init' ) );
	}

	public function wc_current_year_shortcode_add_plugin_page() {
		add_options_page(
			'Current Year Shortcode (for Post Titles)', // page_title
			'Current Year Shortcode (for Post Titles)', // menu_title
			'manage_options', // capability
			'wc-current-year-shortcode', // menu_slug
			array( $this, 'wc_current_year_shortcode_create_admin_page' ) // function
		);
	}

	public function wc_current_year_shortcode_create_admin_page() {
		$this->wc_current_year_shortcode_options = get_option( 'wc_current_year_shortcode_option_name' ); ?>

		<div class="wrap">
			<h2>Current Year Shortcode (for Post Titles)</h2>
			<p>Shortcode: [wcyear]</p>
			<?php settings_errors(); ?>

			<form method="post" action="options.php">
				<?php
					settings_fields( 'wc_current_year_shortcode_option_group' );
					do_settings_sections( 'wc-current-year-shortcode-admin' );
					submit_button();
				?>
			</form>
		</div>
	<?php }

	public function wc_current_year_shortcode_page_init() {
		register_setting(
			'wc_current_year_shortcode_option_group', // option_group
			'wc_current_year_shortcode_option_name', // option_name
			array( $this, 'wc_current_year_shortcode_sanitize' ) // sanitize_callback
		);

		add_settings_section(
			'wc_current_year_shortcode_setting_section', // id
			'Settings', // title
			array( $this, 'wc_current_year_shortcode_section_info' ), // callback
			'wc-current-year-shortcode-admin' // page
		);

		add_settings_field(
			'enable_shortcode_in_titles_0', // id
			'Enable Shortcode in titles', // title
			array( $this, 'enable_shortcode_in_titles_0_callback' ), // callback
			'wc-current-year-shortcode-admin', // page
			'wc_current_year_shortcode_setting_section' // section
		);

		add_settings_field(
			'enable_shortcode_in_yoast_seo_plugin_1', // id
			'Enable Shortcode in Yoast SEO Plugin', // title
			array( $this, 'enable_shortcode_in_yoast_seo_plugin_1_callback' ), // callback
			'wc-current-year-shortcode-admin', // page
			'wc_current_year_shortcode_setting_section' // section
		);
	}

	public function wc_current_year_shortcode_sanitize($input) {
		$sanitary_values = array();
		if ( isset( $input['enable_shortcode_in_titles_0'] ) ) {
			$sanitary_values['enable_shortcode_in_titles_0'] = $input['enable_shortcode_in_titles_0'];
		}

		if ( isset( $input['enable_shortcode_in_yoast_seo_plugin_1'] ) ) {
			$sanitary_values['enable_shortcode_in_yoast_seo_plugin_1'] = $input['enable_shortcode_in_yoast_seo_plugin_1'];
		}

		return $sanitary_values;
	}

	public function wc_current_year_shortcode_section_info() {
		
	}

	public function enable_shortcode_in_titles_0_callback() {
		printf(
			'<input type="checkbox" name="wc_current_year_shortcode_option_name[enable_shortcode_in_titles_0]" id="enable_shortcode_in_titles_0" value="enable_shortcode_in_titles_0" %s>',
			( isset( $this->wc_current_year_shortcode_options['enable_shortcode_in_titles_0'] ) && $this->wc_current_year_shortcode_options['enable_shortcode_in_titles_0'] === 'enable_shortcode_in_titles_0' ) ? 'checked' : ''
		);
	}

	public function enable_shortcode_in_yoast_seo_plugin_1_callback() {
		printf(
			'<input type="checkbox" name="wc_current_year_shortcode_option_name[enable_shortcode_in_yoast_seo_plugin_1]" id="enable_shortcode_in_yoast_seo_plugin_1" value="enable_shortcode_in_yoast_seo_plugin_1" %s>',
			( isset( $this->wc_current_year_shortcode_options['enable_shortcode_in_yoast_seo_plugin_1'] ) && $this->wc_current_year_shortcode_options['enable_shortcode_in_yoast_seo_plugin_1'] === 'enable_shortcode_in_yoast_seo_plugin_1' ) ? 'checked' : ''
		);
	}

}
if ( is_admin() )
	$wc_current_year_shortcode = new WCCurrentYearShortcode();


    
    if ( get_option( 'wc_current_year_shortcode_option_name' )['enable_shortcode_in_titles_0'] == 'enable_shortcode_in_titles_0' ) {
        add_filter( 'the_title', 'do_shortcode' );
    }

    if ( get_option( 'wc_current_year_shortcode_option_name' )['enable_shortcode_in_yoast_seo_plugin_1'] == 'enable_shortcode_in_yoast_seo_plugin_1' ) {
        add_filter( 'wpseo_title', 'do_shortcode' );
    }

	function wc_current_year_shortcode_wcyear_func() {
		return date("Y");
	}
	add_shortcode('wcyear', 'wc_current_year_shortcode_wcyear_func');

?>